
  STATIC SINGLE ASSIGNMENT PROGRAM REPRESENTATION
  ===============================================

  Copyright  2000 Patryk Zadarnowski pat@jantar.org

  Redistribution  and  use  in  source  and  binary  forms,  with  or  without
  modification, are permitted provided  that the following conditions are met:
  (1) Redistributions of  source code must retain the  above copyright notice,
  this list  of conditions and the following  disclaimer.  (2) Redistributions
  in  binary form  must reproduce  the above  copyright notice,  this  list of
  conditions and  the following disclaimer  in the documentation  and/or other
  materials provided  with the distribution.  (3)  The name of  any author may
  not  be used  to  endorse or  promote  products derived  from this  software
  without their specific prior written permission.

  THIS SOFTWARE IS  PROVIDED ``AS IS AND ANY  EXPRESS OR IMPLIED WARRANTIES,
  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
  FITNESS FOR  A PARTICULAR  PURPOSE, ARE DISCLAIMED.   IN NO EVENT  SHALL THE
  AUTHORS BE LIABLE FOR  ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
  OR  CONSEQUENTIAL DAMAGES  (INCLUDING, BUT  NOT LIMITED  TO,  PROCUREMENT OF
  SUBSTITUTE  GOODS OR SERVICES;  LOSS OF  USE, DATA  OR PROFITS;  OR BUSINESS
  INTERRUPTION)  HOWEVER CAUSED  AND ON  ANY THEORY  OF LIABILITY,  WHETHER IN
  CONTRACT,  STRICT LIABILITY,  OR  TORT (INCLUDING  NEGLIGENCE OR  OTHERWISE)
  ARISING IN ANY WAY  OUT OF THE USE OF THIS SOFTWARE,  EVEN IF ADVISED OF THE
  POSSIBILITY OF SUCH DAMAGE.

	$Id: SSA.lhs,v 1.5 2003/03/31 09:09:39 patrykz Exp $

   --------------------------------------------------------------------------


  OVERVIEW
  ========

  This module collects all definitions pertaining to a canonical
  implementation of the static single assignment form of program
  representation. The "SSASyntax" module provides the abstract syntax and a
  pretty printer for it. The "SSAParser" module implements the "parse"
  function which defines the concrete syntax for SSA programs, and "SSAInterp"
  implements "eval", which interprets SSA programs, thus defining its
  semantics.

> module SSA (
>  module SSAPrims,	-- list of SSA primitives ("prims")
>  module SSASyntax,	-- the abstract syntax and a pretty-printer ("show")
>  module SSAParser,	-- the concrete syntax and a parser for it ("parse")
>  module SSAChecker,	-- a well-formedness checker ("check")
>  module SSARenamer,	-- variable renamer ("rename")
>  module SSAInterp,	-- interpreter ("eval")
> ) where

> import SSAPrims
> import SSASyntax
> import SSAParser
> import SSAChecker
> import SSARenamer
> import SSAInterp
