
  Set Compatibility Library
  =========================

  Copyright  2000 Patryk Zadarnowski pat@jantar.org

  Redistribution  and  use  in  source  and  binary  forms,  with  or  without
  modification, are permitted provided  that the following conditions are met:
  (1) Redistributions of  source code must retain the  above copyright notice,
  this list  of conditions and the following  disclaimer.  (2) Redistributions
  in  binary form  must reproduce  the above  copyright notice,  this  list of
  conditions and  the following disclaimer  in the documentation  and/or other
  materials provided  with the distribution.  (3)  The name of  any author may
  not  be used  to  endorse or  promote  products derived  from this  software
  without their specific prior written permission.

  THIS SOFTWARE IS  PROVIDED ``AS IS AND ANY  EXPRESS OR IMPLIED WARRANTIES,
  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
  FITNESS FOR  A PARTICULAR  PURPOSE, ARE DISCLAIMED.   IN NO EVENT  SHALL THE
  AUTHORS BE LIABLE FOR  ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
  OR  CONSEQUENTIAL DAMAGES  (INCLUDING, BUT  NOT LIMITED  TO,  PROCUREMENT OF
  SUBSTITUTE  GOODS OR SERVICES;  LOSS OF  USE, DATA  OR PROFITS;  OR BUSINESS
  INTERRUPTION)  HOWEVER CAUSED  AND ON  ANY THEORY  OF LIABILITY,  WHETHER IN
  CONTRACT,  STRICT LIABILITY,  OR  TORT (INCLUDING  NEGLIGENCE OR  OTHERWISE)
  ARISING IN ANY WAY  OUT OF THE USE OF THIS SOFTWARE,  EVEN IF ADVISED OF THE
  POSSIBILITY OF SUCH DAMAGE.

   --------------------------------------------------------------------------


> module Set (
>  Set, emptySet, isEmptySet, elementOf, addToSet, setToList, mkSet, minusSet
> ) where

> import Data.Set (Set)
> import qualified Data.Set as Set

> emptySet :: Set a
> emptySet = Set.empty

> isEmptySet :: Set a -> Bool
> isEmptySet s = Set.null s

> elementOf :: Ord a => a -> Set a -> Bool
> elementOf a s = Set.member a s

> addToSet :: Ord a => Set a -> a -> Set a
> addToSet s a = Set.insert a s

> setToList :: Set a -> [a]
> setToList s = Set.toList s

> mkSet :: Ord a => [a] -> Set a
> mkSet as = Set.fromList as

> minusSet :: Ord a => Set a -> Set a -> Set a
> minusSet s1 s2 = Set.difference s1 s2


